/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/*
 *  Regle.java
 *  2003-2004 Darnet Camille, Vouriot Thierry
 *  camsss@fr.st, yeri@fr.st
 *  http://www.yeri.fr.st
 *
 */
package merja.associations.regles;

import merja.associations.Hash;

public class Regle {
    private int[] first;
    private int supportFirst;
    private int[] second;
    private int supportSecond;
    private boolean valable;
    private double confiance;
    
    public Regle(int[] first,int[] second){
        this.first=first;
        this.second=second;
        valable=true;
    }
    
    public int[] getFirst(){
        return first;
    }
    
    public int[] getSecond(){
        return second;
    }
    
    public boolean getValable(){
        return valable;
    }
    
    public boolean exist(Regle regle){
        int i,j;
        if (regle.first.length==this.first.length){
            for(i=0;i<first.length;i++){
                if (first[i]!=regle.first[i]) return false;
            }
        }
        else return false;
        
        if (regle.second.length==this.second.length){
            for(i=0;i<second.length;i++){
                if (second[i]!=regle.second[i]) return false;
            }
        }
        else return false;
        
        
        return true;
    }
    
    private boolean exist(int itemId){
        int i;
        boolean resu=false;
        for(i=0;i<second.length;i++){
            if (itemId==second[i])resu=true;
        }
        return resu;
    }
    // test si itemsID est un ss-ensemble de second.
    public boolean exist(int[] itemsId){
        int nbTest=second.length;
        int i,j;
        boolean test=true;
        j=0;
        for(i=0;(i<nbTest)&&(test);i++){
            test=false;
            while((j<itemsId.length)&&(!test)){
                test=exist(itemsId[j]);
                j++;
            }
        }
        return test;
    }
    
    
    
    //!!! utiliser un recherche dichtomique car les id st trie !!!!
 /* public boolean exist_old(int[] itemsId,int niveau){
    !!REFAIRE
    int i,j,k,l;
    boolean test1=false;
    boolean test2=false;
    boolean test3=false;
// test l'existence d'un sous motif des itemsID
    // dans la second regle
    // niveau 2
    // [1,2,3] => [4,11,14]
    // [4,7,8,9,11,12,14]  ??
  
    // tout les elementsd de items
    for(j=0;j<itemsId.length-niveau;j++){
      i=0;
      while((i<second.length)&&(!test1)){
        if (second[i]==itemsId[j]) test1=true;
        else i++;
      }
      if (test1){
        for(l=j+1;l<itemsId.length;l++){
          for(k=0;k<niveau;k++){
  
          }
        }
      }
    }
  }
  */
    public Regle[] geneDescendant(){
        Regle[] descendant=null;
        int i,j,l;
        int valueSwitch;
        int[] firstDesc=new int[first.length-1];
        int[] secondDesc=new int[second.length+1];
        for(i=0;i<first.length;i++){
            valueSwitch=first[i];
            l=0;
            for(j=0;j<second.length;j++){
                if (second[j]<valueSwitch){
                    secondDesc[l]=second[j];
                    
                }
                else{
                    secondDesc[l]=valueSwitch;
                    valueSwitch=-1;
                    j--;
                }
                l++;
            }
        }
        return descendant;
    }
    
    public void setValable( boolean valable){
        this.valable=valable;
    }
    
    public void setSupportFirst(int firstSupport){
        this.supportFirst=firstSupport;
    }
    
    public void setSupportSecond(int secondSupport){
        this.supportSecond=secondSupport;
    }
    
    public void setConfiance(double conf){
        this.confiance=conf;
    }
    
    public double getConfiance(){
        return this.confiance;
    }
    
    public String toString(Hash h){
        StringBuffer resu= new StringBuffer("");
        int i;
        // if (this.valable){
        for (i = 0; i < first.length - 1; i++)
            resu.append((h.getItem(first[i])).toString() + " , ");
        resu.append((h.getItem(first[i])).toString());
        resu.append(" ("+supportFirst +") ");
        resu.append(" => ");
        for (i = 0; i < second.length - 1; i++)
            resu.append((h.getItem(second[i])).toString() + " , ");
        resu.append((h.getItem(second[i])).toString() + " : ");
        resu.append(" ("+supportSecond+") ");
        //resu += valable;
        resu.append(" " + ( ( ( (double) ( (int) (confiance * 1000))) / 1000)));
        resu.append("\n");
        //}
        return resu.toString();
    }
    
}