/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/*
 *  ActionDelete.java
 *  2003-2004 Darnet Camille, Vouriot Thierry
 *  camsss@ifrance.com, yeri@fr.st
 *  http://www.yeri.fr.st
 *
 */
package merja.gui.actions;

/** Class grant l'action "delete"
 */
public class ActionDelete extends MerjaAction {
    
    /** Constructeur
     */  
    public ActionDelete() {
        super("delete");
    }
    
    /** Action qui ferme le fichier courant et efface toutes les zones
     * @param actionEvent vnement gnrant l'action
     */    
    public void actionPerformed(java.awt.event.ActionEvent actionEvent) {
        System.out.println("Action: " + m_name);
        
        if (m_frame.getAlgoInterface() != null) {
            
            m_frame.getLogPanel().logMessage("Fermeture base de donnes : " + m_frame.getTR().getRelationName());
            
            m_frame.getDataPanel().cleanAll();
            m_frame.getAssociationRulesPanel().cleanAll();
            m_frame.getFileDBPanel().cleanAll();
            m_frame.getFileDBPanel().cleanAll();
            m_frame.getItemsetsPanel().cleanAll();
            
            m_frame.setAlgoInterface(null);
            
            m_frame.activePanelsAndButtons(true, false, false, false);
            m_frame.setTabPanel(m_frame.getFileDBPanel());
            
        }
    }
}
