/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/*
 *  MerjaAction.java
 *  2003-2004 Darnet Camille, Vouriot Thierry
 *  camsss@ifrance.com, yeri@fr.st
 *  http://www.yeri.fr.st
 *
 */
package merja.gui.actions;

import java.awt.event.*;
import merja.gui.*;

/** Class abstraite permettant de definir une action
 */
public abstract class MerjaAction implements ActionListener {
    
    /** Fentre principale de l'application */
    protected static MerjaFrame m_frame = null;
    
    /** Nom de l'action */
    protected String m_name;
    
    /** Cration d'une nouvelle action designe par son nom
     * @param name nom de l'action
     */
    public MerjaAction(String name) {
        this.m_name = name;
    }
    
    /** Retourne le nom de l'action
     * @return nom de l'action
     */
    public String getName() {
        return m_name;
    }
    
    /** Change la frame de l'application utilise pour effectuer des actions
     * @param fentre principale de l'application
     */
    public static void setFrame(MerjaFrame frame) {
        m_frame = frame;
    }
}